/*
	Company:            Sensaura Ltd
	Copyright:          (C) 2000

	File Name:		    applicat.h
	File Description:	Header file for definition of Application class
	Author:			    Adam Philp
	Last Update:		04-JAN-00

	Target Compiler:	Microsoft Visual C++ Version 5.0
*/

#ifndef __applicat_h					// Sentry, use file only if it's not already included					
#define __applicat_h

///////////////////////	Included files ////////////////////////////////////////////////////////////

#include "mainwnd.h"

///////////////////////	Class declarations ////////////////////////////////////////////////////////

/*
	Class:				Application
	Description:		Generic windows application class
*/

class Application 
{
public:									// Public constructor and destructor
	Application(LPCSTR, HINSTANCE, HINSTANCE, LPSTR, int);
	virtual ~Application();

public:									// Public member functions
	int				Run();
	HINSTANCE		GetInstance() const { return m_hInstance; }
	LPCSTR			GetName() const { return m_pName; }
	MainWnd*		GetMainWindow() const { return m_pMainWindow; }

protected:								// Protected member functions
	virtual bool	InitApplication();
	virtual bool	InitInstance();
	virtual int		MessageLoop();
	virtual bool	PreProcessMsg(MSG&);

protected:								// Protected data members
	HINSTANCE		m_hInstance;
	HINSTANCE		m_hPrevInstance;
	LPCSTR			m_pName;
	MainWnd*		m_pMainWindow;
	HACCEL			m_hAccelTable;

private:								// Private data members
	int				m_nCmdShow;
};

#endif									// End of sentry __applicat_h
