/*
	Company:            Sensaura Ltd
	Copyright:          (C) 1999

	File Name:		    lstnrdlg.h
	File Description:	Header file for declaration of ListenerDlg class
	Author:			    Adam Philp
	Last Update:		21-DEC-99

	Target Compiler:	Microsoft Visual C++ Version 5.0
*/

#ifndef __lstnrdlg_h					// Sentry, use file only if it's not already included
#define __lstnrdlg_h

/////////////////////// Included files ////////////////////////////////////////////////////////////

#include "applicat.h"
#include <dsound.h>

///////////////////////	Class definition //////////////////////////////////////////////////////////

/*
	Class:				ListenerDlg
	Description:		Dialog class allowing user to edit 3D listener properties
*/

class ListenerDlg
{
friend BOOL CALLBACK ListenerDlgProc(HWND, UINT, WPARAM, LPARAM);

public:									// Public constructor and destructor
    ListenerDlg();
    ~ListenerDlg();

public:									// Public member functions
	bool Create(Application*, LPDIRECTSOUND3DLISTENER);

public:									// Public data members
	HWND					m_hWnd;
	HINSTANCE				m_hInstance;
	LPDIRECTSOUND3DLISTENER	m_pListener;

protected:								// Protected member functions
    BOOL OnInitDialog(HWND, WPARAM);
    BOOL OnCommand(WPARAM, LPARAM);
	BOOL OnHScroll(WORD, LONG, HWND);
    void OnDestroy();

	BOOL InitControls(HWND);
	void SetFactors();
	void SetPosition();
	void SetOrientation();
	void SetFactorStatics();
	void SetPositionStatics();
	void SetOrientationStatics();

protected:								// Protected data members
	HWND m_hDistanceSlider, m_hDopplerSlider, m_hRolloffSlider;
	HWND m_hDistanceStatic, m_hDopplerStatic, m_hRolloffStatic;
	HWND m_hXSlider, m_hYSlider, m_hZSlider;
	HWND m_hXStatic, m_hYStatic, m_hZStatic;
	HWND m_hFrontXSlider, m_hFrontYSlider, m_hFrontZSlider;
	HWND m_hFrontXStatic, m_hFrontYStatic, m_hFrontZStatic;
	HWND m_hTopXSlider, m_hTopYSlider, m_hTopZSlider;
	HWND m_hTopXStatic, m_hTopYStatic, m_hTopZStatic;
	HWND m_hImmediateBtn, m_hDeferredBtn;
	HWND m_hCommitBtn, m_hDefaultBtn;

	DWORD m_dwApply;
};

#endif									// End of sentry __lstnrdlg_h